import Spy = jasmine.Spy;
import { of } from 'rxjs';

import { SpyObject } from './spyobject';
import { SearchService } from 'app/search/service/search-service';

export class MockSearchService extends SpyObject {
  getSpy: Spy;
  keywordsAutoCompleteSpy: Spy;
  authorsAutoCompleteSpy: Spy;
  plAutoCompleteSpy: Spy;

  constructor() {
    super(SearchService);

    this.getSpy = this.spy('get').andReturn(this);
    const keyWordTestData = [
      { target: 'keyword1', hitCount: 5 },
      { target: 'keyword2', hitCount: 3 },
      { target: 'keyword3', hitCount: 2 },
    ];
    this.keywordsAutoCompleteSpy = this.spy('getKeywordsAutoComplete').and.returnValue(of(keyWordTestData));

    const authorTestData = [
      { target: 'Michael', hitCount: 5 },
      { target: 'Lukaus', hitCount: 3 },
      { target: 'Eduard', hitCount: 2 },
    ];
    this.authorsAutoCompleteSpy = this.spy('getContributorCreatorAutoComplete').and.returnValue(of(authorTestData));

    const programmingTestData = [
      { target: 'Java', hitCount: 5 },
      { target: 'Python', hitCount: 3 },
      { target: 'UML', hitCount: 2 },
    ];
    this.plAutoCompleteSpy = this.spy('getProgrammingLanguageAutoComplete').and.returnValue(of(programmingTestData));

    // Add more mock functions!!!
  }
}
